<?php

namespace common\logic\Ticket\Ticket\Repository;

use common\logic\AbstractRepository;

class TicketRepository extends AbstractRepository
{
    protected TicketRepositoryQuery $query;

    public function loadDependencies(): void
    {
        $this->loadQuery(TicketRepositoryQuery::class);
    }

    /**
     * Retourne les options de base nécessaires à la fonction de recherche.
     */
    public function getDefaultOptionsSearch(): array
    {
        return [
            self::WITH => ['user', 'producer', 'ticketMessages'],
            self::JOIN_WITH => [],
            self::ORDER_BY => '',
            self::ATTRIBUTE_ID_PRODUCER => ''
        ];
    }

    public function findOneTicketById(int $id)
    {
        return $this->createQuery()
            ->filterById($id)
            ->findOne();
    }
}