<?php

namespace common\logic\Ticket\Ticket\Service;

use common\logic\AbstractBuilder;
use common\logic\Producer\Producer\Model\Producer;
use common\logic\Ticket\Ticket\Model\Ticket;
use common\logic\User\User\Model\User;

class TicketBuilder extends AbstractBuilder
{
    public function instanciateTicket(Producer $producer, User $user): Ticket
    {
        $ticket = new Ticket();

        $ticket->status = Ticket::STATUS_OPEN;
        $ticket->populateProducer($producer);
        $ticket->populateUser($user);

        return $ticket;
    }

    public function createTicket(Producer $producer, User $user): Ticket
    {
        $ticket = $this->instanciateTicket($producer, $user);
        $this->saveCreate($ticket);

        return $ticket;
    }

    public function updateTicketStatus(Ticket $ticket, string $status)
    {
        $ticket->status = $status;
        $this->saveUpdate($ticket);
    }

    public function closeTicket(Ticket $ticket)
    {
        $this->updateTicketStatus($ticket, Ticket::STATUS_CLOSED);
    }

    public function openTicket(Ticket $ticket)
    {
        $this->updateTicketStatus($ticket, Ticket::STATUS_OPEN);
    }
}