<?php

namespace common\logic\Ticket\Ticket\Service;

use common\logic\AbstractSolver;
use common\logic\Ticket\Ticket\Model\Ticket;
use common\logic\User\User\Model\User;
use common\logic\User\User\Service\UserSolver;

class TicketSolver extends AbstractSolver
{
    protected UserSolver $userSolver;

    public function loadDependencies(): void
    {
        $this->userSolver = $this->loadService(UserSolver::class);
    }

    public function hasTicketAccess(Ticket $ticket, User $user): string
    {
        return $user->id_producer == $ticket->id_producer
            || $this->userSolver->isAdmin($user);
    }

    public function isTicketOpen(Ticket $ticket)
    {
        return $ticket->status == Ticket::STATUS_OPEN;
    }

    public function isTicketClosed(Ticket $ticket)
    {
        return $ticket->status == Ticket::STATUS_CLOSED;
    }
}